<?php

namespace Drupal\workspaces_parallel;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceProviderBase;
use Drupal\workspaces_parallel\Factory\ParallelWorkspaceOperationFactory;
use Drupal\workspaces_parallel\Service\ParallelWorkspaceEntityRepository;

/**
 * Modify some services to use our own.
 *
 * This class must be in the root of /src to be detected by Drupal's service
 * loader. It must also be named specifically.
 *
 * See https://www.drupal.org/docs/drupal-apis/services-and-dependency-injection/altering-existing-services-providing-dynamic-services
 */
class WorkspacesParallelServiceProvider extends ServiceProviderBase {

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container) {
    if ($container->hasDefinition('entity.repository')) {
      $definition = $container->getDefinition('entity.repository');
      $definition->setClass(ParallelWorkspaceEntityRepository::class);
    }

    if ($container->hasDefinition('workspaces.operation_factory')) {
      $definition = $container->getDefinition('workspaces.operation_factory');
      $definition->setClass(ParallelWorkspaceOperationFactory::class);
    }
  }

}
